VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "JukePlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private hDll As Long

Private pGetPluginInfo As Long
Private pSongStart As Long
Private pSongEnd As Long

Private PluginInfo As PluginInfoType

Public Sub Initialize(PluginName As String)
    hDll = LoadLibrary(PluginName)
       
    pGetPluginInfo = GetProcAddress(hDll, "Juke_GetPluginInfo")
    
    If IsPlugin Then
        pSongStart = GetProcAddress(hDll, "Juke_SongStart")
        pSongEnd = GetProcAddress(hDll, "Juke_SongEnd")
        
        GetPluginInfo
    Else
        Shutdown
    End If
End Sub

Public Sub Shutdown()
    FreeLibrary hDll
End Sub

Public Sub GetPluginInfo()
    If pGetPluginInfo <> 0 Then
        CallFuncPtr pGetPluginInfo, PluginInfo.Name, PluginInfo.Author, PluginInfo.Version
    End If
End Sub

Public Sub SongStart(songName As String, songArtist As String, songAlbum As String)
    If pSongStart <> 0 Then
        Dim SongInfo As SongInfoType
        SongInfo.Name = songName + Chr(0)
        SongInfo.Artist = songArtist + Chr(0)
        SongInfo.Album = songAlbum + Chr(0)
        CallFuncPtr pSongStart, SongInfo.Name, SongInfo.Artist, SongInfo.Album
    End If
End Sub

Public Sub SongEnd(songName As String, songArtist As String, songAlbum As String)
    If pSongEnd <> 0 Then
        Dim SongInfo As SongInfoType
        SongInfo.Name = songName + Chr(0)
        SongInfo.Artist = songArtist + Chr(0)
        SongInfo.Album = songAlbum + Chr(0)
        CallFuncPtr pSongEnd, SongInfo.Name, SongInfo.Artist, SongInfo.Album
    End If
End Sub

Public Property Get IsPlugin() As Boolean
    IsPlugin = (pGetPluginInfo <> 0)
End Property

Public Property Get Name() As String
   Name = PluginInfo.Name
End Property

Public Property Get Author() As String
   Author = PluginInfo.Author
End Property

Public Property Get Version() As String
   Version = PluginInfo.Version
End Property

